BEGIN {
	char=32
}

$1 == "poly" {
	char ++
	if(char > 126) {
		print "Too many polys (want 94)" > "/dev/stderr"
		exit 1
	}

	minx=$2
	miny=$3
	maxx=minx
	maxy=miny

	pt=0
	for(i=2; i<NF; i++) {
		x=$i
		i++
		y=$i

		if(x < minx) minx = x;
		if(x > maxx) maxx = x;
		if(y < miny) miny = y;
		if(y > maxy) maxy = y;

		ptx[char,pt] = x
		pty[char,pt] = y

		pt++
	}

	charpts[char] = pt

	if(minx == maxx || miny == maxy) {
		print "Character size 0" > "/dev/stderr"
		exit 1
	}

	width = maxx-minx
	height = maxy-miny

	charw[char] = width;
	charh[char] = height;
	charminx[char] = minx;
	charmaxx[char] = maxx;

	if(char == 33) {
		fminy = miny
		fmaxy = maxy
		fminw = width
		fmaxw = width
	} else {
		if(miny < fminy) fminy = miny;
		if(maxy > fmaxy) fmaxy = maxy;
		if(width < fminw) fminw = width;
		if(width > fmaxw) fmaxw = width;
	}

	print "Character", char, "dimensions", width, height > "/dev/stderr"

	next
}

END {
	if(char < 126) {
		print "Insufficient number of polys (want 94)" > "/dev/stderr"
		exit 1
	}

	if(!fontname) fontname = "polyfont";
	print "Font name", fontname > "/dev/stderr";

	print "Width range", fminw, fmaxw > "/dev/stderr"

	if(monospace) {
		print "Monospace", monospace > "/dev/stderr"
		if(!space) space = monospace;
	}

	if(!space) space = (fminw + fmaxw) / 2;
	print "Space", space > "/dev/stderr"

	if(!skip) skip = fminw;
	print "Skip", skip > "/dev/stderr"

	if(!glyph) glyph = 1;

	printf "!font %s", fontname
	for(i=0; i<95; i++) {
		printf " %d", glyph + i
	}
	printf " %d\n", glyph

	height = fmaxy - fminy

	printf "! %d %g\n", glyph, space/height
	printf "macro hf%d shift %g 0 endmacro\n", glyph, space/height

	for(char=33; char<127; char++) {
		glyph++

		if(monospace) w = monospace; else w = charw[char] + skip;

		shiftx=0;
		if(monospace) {
			shiftx = (monospace - charw[char])/2;
		}

		w /= height;
		printf "! %d %g\n", glyph, w
		printf "macro hf%d apoly", glyph

		for(i=0; i<charpts[char]; i++) {
			x=(ptx[char,i] - charminx[char] + shiftx) / height
			y=(pty[char,i] - fminy) / height
			printf " %g %g", x, y
		}

		printf " shift %g 0 endmacro\n", w
	}
}
